image: "${TEST_DYNAMIC_IMAGE_NAME}:${TEST_DYNAMIC_IMAGE_TAG}"

.npm_or_yarn: &npm_or_yarn
  - npm_or_yarn() { ls yarn.lock &> /dev/null && yarn "$@" || npm "$@"; }

.only_on_changes: &only_on_changes
  changes:
    - config/**/*
    - "*.json"
    - src/**/*
    - .gitlab-ci.yml

variables:
  TEST_DYNAMIC_IMAGE_NAME: "${GLOBAL_IMAGE_NAME:-node}"
  TEST_DYNAMIC_IMAGE_TAG: "${GLOBAL_IMAGE_TAG:-16-alpine}"
  TEST_DYNAMIC_EXECUTE_ALL: ""
  TEST_DYNAMIC_EXECUTE_12: ""
  TEST_DYNAMIC_EXECUTE_14: ""
  TEST_DYNAMIC_EXECUTE_15: ""
  TEST_DYNAMIC_EXECUTE_16: ""

stages:
  - test_dynamic

test_dynamic:12:
  image: node:12-alpine
  stage: test_dynamic
  allow_failure: true
  except:
    - schedules
  before_script:
    - *npm_or_yarn
    - if [ "${TEST_DYNAMIC_IMAGE_NAME}:${TEST_DYNAMIC_IMAGE_TAG}" != "node:12-alpine" ]; then
        rm -rf node_modules;
        npm_or_yarn i;
      fi
  script:
    - cd "$ROOT_PROJECT_FOLDER"
    - npm_or_yarn test
  only:
    <<: *only_on_changes
    variables:
      - $TEST_DYNAMIC_EXECUTE_ALL == "true"
      - $TEST_DYNAMIC_EXECUTE_12 == "true"

test_dynamic:14:
  image: node:14-alpine
  stage: test_dynamic
  allow_failure: true
  except:
    - schedules
  before_script:
    - *npm_or_yarn
    - if [ "${TEST_DYNAMIC_IMAGE_NAME}:${TEST_DYNAMIC_IMAGE_TAG}" != "node:14-alpine" ]; then
        rm -rf node_modules;
        npm_or_yarn i;
      fi
  script:
    - cd "$ROOT_PROJECT_FOLDER"
    - npm_or_yarn test
  only:
    <<: *only_on_changes
    variables:
      - $TEST_DYNAMIC_EXECUTE_ALL == "true"
      - $TEST_DYNAMIC_EXECUTE_14 == "true"

test_dynamic:15:
  image: node:15-alpine
  stage: test_dynamic
  allow_failure: true
  except:
    - schedules
  before_script:
    - *npm_or_yarn
    - if [ "${TEST_DYNAMIC_IMAGE_NAME}:${TEST_DYNAMIC_IMAGE_TAG}" != "node:15-alpine" ]; then
        rm -rf node_modules;
        npm_or_yarn i;
      fi
  script:
    - cd "$ROOT_PROJECT_FOLDER"
    - npm_or_yarn test
  only:
    <<: *only_on_changes
    variables:
      - $TEST_DYNAMIC_EXECUTE_ALL == "true"
      - $TEST_DYNAMIC_EXECUTE_15 == "true"
  
test_dynamic:16:
  image: node:16-alpine
  stage: test_dynamic
  allow_failure: true
  except:
    - schedules
  before_script:
    - *npm_or_yarn
    - if [ "${TEST_DYNAMIC_IMAGE_NAME}:${TEST_DYNAMIC_IMAGE_TAG}" != "node:16-alpine" ]; then
        rm -rf node_modules;
        npm_or_yarn i;
      fi
  script:
    - cd "$ROOT_PROJECT_FOLDER"
    - npm_or_yarn test
  only:
    <<: *only_on_changes
    variables:
      - $TEST_DYNAMIC_EXECUTE_ALL == "true"
      - $TEST_DYNAMIC_EXECUTE_16 == "true"
